> ## Documentation Index
> Fetch the complete documentation index at: https://docs.costgraph.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Register OAuth client

> Dynamic client registration for public clients. Redirect URIs must be absolute https URLs or loopback http URLs.



## OpenAPI

````yaml /api-reference/costgraph/openapi.json post /api/v1/oauth/register
openapi: 3.0.0
info:
  description: Read and manage your CostGraph organization, spend, alerts, and settings.
  title: CostGraph API
  contact: {}
  version: '1.0'
servers:
  - url: https://api.costgraph.ai
security: []
tags:
  - name: ai
    x-group: AI
  - name: ai-serving
    x-group: AI serving
  - name: anomalies
    x-group: Anomalies
  - name: auth
    x-group: Auth
  - name: billing
    x-group: Billing
  - name: billing-export
    x-group: Billing export
  - name: budgets
    x-group: Budgets
  - name: ci
    x-group: CI
  - name: compute-recommendations
    x-group: Compute recommendations
  - name: config
    x-group: Config
  - name: cost
    x-group: Cost
  - name: gpus
    x-group: GPUs
  - name: graphai
    x-group: Graph AI
  - name: infracost
    x-group: Infracost
  - name: integrations
    x-group: Integrations
  - name: invitations
    x-group: Invitations
  - name: kubernetes-clusters
    x-group: Kubernetes clusters
  - name: marketplace
    x-group: Marketplace
  - name: network-requests
    x-group: Network requests
  - name: notifications
    x-group: Notifications
  - name: oauth
    x-group: OAuth
  - name: oauth-clients
    x-group: OAuth clients
  - name: opencost
    x-group: OpenCost
  - name: organization
    x-group: Audit log
  - name: organizations
    x-group: Organizations
  - name: placement-alternatives
    x-group: Placement alternatives
  - name: reports
    x-group: Reports
  - name: service-map
    x-group: Service map
  - name: settings
    x-group: Settings
  - name: sso
    x-group: Single sign-on
  - name: tenants
    x-group: Tenants
  - name: user
    x-group: Users
  - name: virtual-machines
    x-group: Virtual machines
  - name: virtual-tags
    x-group: Virtual tags
  - name: workflows
    x-group: Workflows
paths:
  /api/v1/oauth/register:
    post:
      tags:
        - oauth
      summary: Register OAuth client
      description: >-
        Dynamic client registration for public clients. Redirect URIs must be
        absolute https URLs or loopback http URLs.
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/controllers.RegisterClientRequest'
        description: Client metadata
        required: true
      responses:
        '201':
          description: Created
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/controllers.RegisterClientResponse'
        '400':
          description: Bad Request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/controllers.oauthErrorResponse'
components:
  schemas:
    controllers.RegisterClientRequest:
      type: object
      required:
        - client_name
        - redirect_uris
      properties:
        client_name:
          type: string
        grant_types:
          type: array
          items:
            type: string
        redirect_uris:
          type: array
          minItems: 1
          items:
            type: string
        response_types:
          type: array
          items:
            type: string
        token_endpoint_auth_method:
          type: string
    controllers.RegisterClientResponse:
      type: object
      properties:
        client_id:
          type: string
        client_id_issued_at:
          type: integer
        client_name:
          type: string
        grant_types:
          type: array
          items:
            type: string
        redirect_uris:
          type: array
          items:
            type: string
        response_types:
          type: array
          items:
            type: string
        token_endpoint_auth_method:
          type: string
    controllers.oauthErrorResponse:
      type: object
      properties:
        error:
          type: string
        error_description:
          type: string

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.